﻿#region Copyright Syncfusion Inc. 2001 - 2010
//
//  Copyright Syncfusion Inc. 2001 - 2010. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.ComponentModel;
using System.IO;
using System.Drawing;
using System.Data.OleDb;
using System.Text.RegularExpressions;

public partial class _Default : System.Web.UI.Page
{
    
    # region Page Load
    /// <summary>
    /// Handles page load
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
       
    }
    # endregion
    
    # region Events
    /// <summary>
    /// Creates spreadsheet
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Button1_Click(object sender, EventArgs e)
    {
        //Opens the template document
        WordDocument document = new WordDocument(Server.MapPath(@"App_Data\Template.docx"));
        //Gets the bookmark by it's name
        Syncfusion.DocIO.DLS.Bookmark bookmark = document.Bookmarks.FindByName("B1");
        //Gets the owner paragraph of Bookmart start
        WParagraph para = bookmark.BookmarkStart.OwnerParagraph;
        //Checks whether paragaph is defined within table cell
        WTableRow row = null;
        int tableIndex = 0;
        WTable templateTable = null;
        //Checks whether paragraph is in cell?
        if (para.IsInCell)
        {
            //Gets the template row
            row = GetTableRow(para);
            //Gets the template table
            templateTable = row.Owner as WTable;
            //Clones the template table to the document
            tableIndex = document.LastSection.Tables.Add(templateTable.Clone());
        }

        //Clones the template row to the new table
        for (int i = 0; i < 5; i++)
        {
            document.LastSection.Tables[tableIndex].Rows.Add(row.Clone());
        }
        //Removes the template table from the document.
        document.LastSection.Body.ChildEntities.Remove(templateTable);

        if (rdButtonWord97To2003.Checked)
        {
            //Save as .doc Word 97-2003 format
            document.Save("Generate Word.doc", FormatType.Doc, Response, HttpContentDisposition.Attachment);
        }
        //Save as .docx Word2007 format
        else if (rdButtonWord2007.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2007, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2007 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
        //Save as .docx Word2010 format
        else if (rdButtonWord2010.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2010, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2010 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
        //Save as .docx Word2013 format
        else if (rdButtonWord2013.Checked)
        {
            try
            {
                document.Save("Generate Word.docx", FormatType.Word2013, Response, HttpContentDisposition.Attachment);
            }
            catch (Win32Exception ex)
            {
                Response.Write("Word 2013 is not installed in this system");
                Console.WriteLine(ex.ToString());
            }
        }
    }
    # endregion
    #region Helpher Methods
    private WTableRow GetTableRow(Entity entity)
    {
        //Checks until WTable entity
        while (!(entity is WTableRow))
        {
            if (entity.Owner != null)
                entity = entity.Owner;
            else
                break;
        }
        return entity as WTableRow;
    }
    #endregion
}
